<template id="report">
  <div>
    <div class="report-page-top not-print">
      <vue-monthly-picker v-model="selectedMonth" alignment="center" placeholder="Select month"></vue-monthly-picker>
      <br />
      <button class="btn btn-success" @click="print">Download PDF</button>
      <button class="btn btn-success" @click="getMonthlyReport">Get report</button>
    </div>
    <div class="charts-container">
      <MainStats class="not-print" v-bind:selectedMonth="selectedMonth"></MainStats>
      <div class="main-stats">
        <h1>Report {{selectedMonth}}</h1>
        <p>{{ annualAvg.amount}} € {{ annualAvg.label }}</p>
        <p>{{ currMonth.amount}} € {{ currMonth.label }}</p>
        <p
          v-if="savingAchievements.amount != 'Start collecting!'"
        >{{ savingAchievements.amount}} € {{ savingAchievements.label }}</p>
      </div>

      <div class="print-stats row">
        <div v-if="mostExpBeneficiaries != ''" class="col-md-6 col-sm-12">
          <br />
          <MostExpBenef v-bind:mostExpBenef="mostExpBeneficiaries"></MostExpBenef>
        </div>
        <div v-if="mostExpTransactions != ''" class="col-md-6 col-sm-12">
          <br />
          <MostExpTransactions v-bind:mostExpTransactions="mostExpTransactions"></MostExpTransactions>
        </div>
      </div>

      <div class="print-stats row">
        <div class="col-md-12 col-sm-12">
          <br />
          <CategoriesStats v-if="categoriesStats.length > 0" v-bind:categoriesStats="categoriesStats"></CategoriesStats>
        </div>
      </div>

      <div class="print-stats row">
        <div
          class="col-md-12 col-sm-12"
          v-for="savingCampaign in savingCampaigns"
          v-bind:key="savingCampaign.id"
        >
          <br />
          <SavingCampaignsReportStats v-bind:savingCampaign="savingCampaign"></SavingCampaignsReportStats>
        </div>
      </div>
    </div>
  </div>
</template>

<style>
.fade-enter-active,
.fade-leave-active {
  transition-property: opacity;
  transition-duration: 0.25s;
}

.fade-enter-active {
  transition-delay: 0.25s;
}

.fade-enter,
.fade-leave-active {
  opacity: 0;
}
</style>
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.18.1/moment.min.js"></script>
<script src="https://code.iconify.design/1/1.0.4/iconify.min.js"></script>
<script>
import jsPDF from "jspdf";
import "jspdf-autotable";
import CategoriesStats from "./report/CategoriesStats.vue";
import MostExpBenef from "./report/MostExpBenef";
import SavingCampaignsReportStats from "./report/SavingCampaignsReportStats";
import MostExpTransactions from "./report/MostExpTransactions.vue";
import VueMonthlyPicker from "vue-monthly-picker";
import MainStats from "./report/MainStats.vue";
import moment from "moment";

export default {
  components: {
    CategoriesStats,
    MostExpBenef,
    MostExpTransactions,
    VueMonthlyPicker,
    MainStats,
    SavingCampaignsReportStats
  },

  data: function() {
    return {
      selectedMonth: moment(new Date()).format("YYYY-MM"),
      mostExpTransactions: "",
      mostExpBenef: "",
      savingAchievements: "",
      annualAvg: "",
      currMonth: "",
      categoriesStats: "",
      mostExpBeneficiaries: "",
      mostExpTransactions: "",
      savingCampaigns: ""
    };
  },

  created: function() {
    this.getReport(this.selectedMonth);

    this.currMonth, this.annualAvg, this.savingAchievements;

    Fire.$on(
      "AfterGotSummaryStats",
      (currMonth, annualAvg, savingAchievements) => {
        this.currMonth = currMonth;
        this.annualAvg = annualAvg;
        this.savingAchievements = savingAchievements;
      }
    );
  },

  methods: {
    print: function() {
      window.print();
    },
    getMonthlyReport() {
      Fire.$emit("GetSummaryStats");
      this.selectedMonth = moment(this.selectedMonth).format("YYYY-MM");
      this.getReport(this.selectedMonth);
    },

    getReport: function(date) {
      this.$Progress.start();
      let uri = "api/report/" + date;

      axios
        .get(uri)
        .then(response => {
          this.categoriesStats = response.data.categoriesStats;
          this.mostExpBeneficiaries = response.data.mostExpBenef;
          this.mostExpTransactions = response.data.mostExpTransactions;
          this.savingCampaigns = response.data.savingCampaigns;
          this.$Progress.finish();
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    }
  }
};
</script>